#include <stdio.h>
#include <string.h>
#include "BeaRhs.h"

rec *Scores::loadFromFile(char *path)
{
	FILE *f;
	fopen_s(&f, path, "r");
	if (!f) return NULL;

	char tmpName[40]="Qertis";
	long int tmpScore=0;

	rec *scores = new rec;
	strcpy_s(scores->heroName, sizeof(char)*40, tmpName);
	scores->score=0;
	rec *now=scores;

	int i=0;
	while (fscanf(f, "%s %d\n", &tmpName, &tmpScore)!=-1)
	{
		now->next=new rec;
		now=now->next;
		strcpy_s(now->heroName, sizeof(char)*40, tmpName);
		now->score=tmpScore;
		now->next=NULL;
		i++;
	}
	fclose(f);
	scores->score=i;
	return scores;
}

int Scores::saveToFile(char *path, rec *scores)
{
	FILE *f;
	fopen_s(&f, path, "w");	
	if (!f) return -1;
	if (scores->next==NULL) return -1;

	int i=0;	
	rec *now=scores->next;
	while (1)
	{
		++i;
		fprintf_s(f, "%s %ld\n", now->heroName, now->score);
		if (now->next==NULL) return -1;
		now=now->next;
	}
	fclose(f);
	return i;
}


int Scores::insToList(rec *scores, rec toIns)
{
	if (scores->next==NULL || scores->next->score < toIns.score)
	{
		rec *ptr=scores->next;
		scores->next = new rec;
		strcpy_s(scores->next->heroName, sizeof(char)*40, toIns.heroName);
		scores->next->score = toIns.score;
		scores->next->next = ptr;
		return 0;
	}
	rec *now=scores->next;
	while (1)
	{
		if (now->score >= toIns.score && (now->next==NULL || now->next->score <= toIns.score))
		{
			rec *ptr=now->next;
			now->next = new rec;
			strcpy_s(now->next->heroName, sizeof(char)*40, toIns.heroName);
			now->next->score = toIns.score;
			now->next->next = ptr;
			scores->score++;
			return 0;
		}
		if (now->score < toIns.score) return -1;
		now=now->next;
		if (now==NULL) return -1;
	}
	return 0;
}
rec *Scores::getByNumber (rec *scores, unsigned int numb)
{
	if (scores->next==NULL) return NULL;
	rec *now=scores->next;
	for (int i=0; i!=numb; i++)
	{
		if (now->next==NULL) return NULL;
		now=now->next;
	}
	return now;
}